<?php
/**
 * Plugin Name: Car Rental Software - OTA Booking Engine
 * Plugin URI: http://www.car-rental-software.it
 * Description: Car Rental Software - OTA Booking Engine Plugin
 * Author: My Appy
 * Author URI: http://www.myappy.it/
 * Version: 1.0.1
 * Text Domain: otabo
 *
 * Copyright: (c) 2020 My Appy (info@myappy.net)
 *
 * @author    My Appy
 * @copyright Copyright (c) 2020, My Appy
 *
 */
 
define('DEBUG', 1);

class Otabo
{
	var $COUNTRIES = [["code"=>"IT","name"=>"ITALIA"],["code"=>"AF","name"=>"AFGHANISTAN"],["code"=>"AL","name"=>"ALBANIA"],["code"=>"DZ","name"=>"ALGERIA"],["code"=>"AD","name"=>"ANDORRA"],["code"=>"AO","name"=>"ANGOLA"],["code"=>"AI","name"=>"ANGUILLA"],["code"=>"AG","name"=>"ANTIGUA E BARBUDA"],["code"=>"AN","name"=>"ANTILLE OLANDESI"],["code"=>"SA","name"=>"ARABIA SAUDITA"],["code"=>"AR","name"=>"ARGENTINA"],["code"=>"AM","name"=>"ARMENIA"],["code"=>"AW","name"=>"ARUBA"],["code"=>"AU","name"=>"AUSTRALIA"],["code"=>"AT","name"=>"AUSTRIA"],["code"=>"AZ","name"=>"AZERBAIGIAN"],["code"=>"BS","name"=>"BAHAMAS"],["code"=>"BH","name"=>"BAHRAIN"],["code"=>"BD","name"=>"BANGLADESH"],["code"=>"BB","name"=>"BARBADOS"],["code"=>"BE","name"=>"BELGIO"],["code"=>"BZ","name"=>"BELIZE"],["code"=>"BJ","name"=>"BENIN"],["code"=>"BM","name"=>"BERMUDA"],["code"=>"BT","name"=>"BHUTAN"],["code"=>"BY","name"=>"BIELORUSSIA"],["code"=>"MM","name"=>"BIRMANIA"],["code"=>"BO","name"=>"BOLIVIA"],["code"=>"BQ","name"=>"BONAIRE"],["code"=>"BA","name"=>"BOSNIA ED ERZEGOVINA"],["code"=>"BW","name"=>"BOTSWANA"],["code"=>"BR","name"=>"BRASILE"],["code"=>"BN","name"=>"BRUNEI"],["code"=>"BG","name"=>"BULGARIA"],["code"=>"BF","name"=>"BURKINA FASO"],["code"=>"BI","name"=>"BURUNDI"],["code"=>"KH","name"=>"CAMBOGIA"],["code"=>"CM","name"=>"CAMERUN"],["code"=>"CA","name"=>"CANADA"],["code"=>"CV","name"=>"CAPO VERDE"],["code"=>"TD","name"=>"CIAD"],["code"=>"CL","name"=>"CILE"],["code"=>"CN","name"=>"CINA"],["code"=>"CY","name"=>"CIPRO"],["code"=>"VA","name"=>"CITTÃ€ DEL VATICANO"],["code"=>"CO","name"=>"COLOMBIA"],["code"=>"KM","name"=>"COMORE"],["code"=>"KP","name"=>"COREA DEL NORD"],["code"=>"KR","name"=>"COREA DEL SUD"],["code"=>"CI","name"=>"COSTA D'AVORIO"],["code"=>"CR","name"=>"COSTA RICA"],["code"=>"HR","name"=>"CROAZIA"],["code"=>"CU","name"=>"CUBA"],["code"=>"CW","name"=>"CURAÃ‡AO"],["code"=>"DK","name"=>"DANIMARCA"],["code"=>"DM","name"=>"DOMINICA"],["code"=>"EC","name"=>"ECUADOR"],["code"=>"EG","name"=>"EGITTO"],["code"=>"SV","name"=>"EL SALVADOR"],["code"=>"AE","name"=>"EMIRATI ARABI UNITI"],["code"=>"ER","name"=>"ERITREA"],["code"=>"EE","name"=>"ESTONIA"],["code"=>"ET","name"=>"ETIOPIA"],["code"=>"FJ","name"=>"FIGI"],["code"=>"PH","name"=>"FILIPPINE"],["code"=>"FI","name"=>"FINLANDIA"],["code"=>"FR","name"=>"FRANCIA"],["code"=>"GA","name"=>"GABON"],["code"=>"GM","name"=>"GAMBIA"],["code"=>"GE","name"=>"GEORGIA"],["code"=>"GS","name"=>"GEORGIA DEL SUD E ISOLE SANDWICH MERIDIONALI"],["code"=>"DE","name"=>"GERMANIA"],["code"=>"GH","name"=>"GHANA"],["code"=>"JM","name"=>"GIAMAICA"],["code"=>"JP","name"=>"GIAPPONE"],["code"=>"DJ","name"=>"GIBUTI"],["code"=>"JO","name"=>"GIORDANIA"],["code"=>"GR","name"=>"GRECIA"],["code"=>"GD","name"=>"GRENADA"],["code"=>"GL","name"=>"GROENLANDIA"],["code"=>"GP","name"=>"GUADALUPA"],["code"=>"GU","name"=>"GUAM"],["code"=>"GT","name"=>"GUATEMALA"],["code"=>"GN","name"=>"GUINEA"],["code"=>"GQ","name"=>"GUINEA EQUATORIALE"],["code"=>"GW","name"=>"GUINEA-BISSAU"],["code"=>"GY","name"=>"GUYANA"],["code"=>"GF","name"=>"GUYANA FRANCESE"],["code"=>"HT","name"=>"HAITI"],["code"=>"HN","name"=>"HONDURAS"],["code"=>"HK","name"=>"HONG KONG"],["code"=>"IN","name"=>"INDIA"],["code"=>"ID","name"=>"INDONESIA"],["code"=>"IR","name"=>"IRAN"],["code"=>"IQ","name"=>"IRAQ"],["code"=>"IE","name"=>"IRLANDA"],["code"=>"IS","name"=>"ISLANDA"],["code"=>"CX","name"=>"ISOLA DEL NATALE"],["code"=>"NF","name"=>"ISOLA NORFOLK"],["code"=>"KY","name"=>"ISOLE CAYMAN"],["code"=>"CC","name"=>"ISOLE COCOS E KEELING"],["code"=>"CK","name"=>"ISOLE COOK"],["code"=>"FK","name"=>"ISOLE FALKLAND"],["code"=>"MP","name"=>"ISOLE MARIANNE SETTENTRIONALI"],["code"=>"MH","name"=>"ISOLE MARSHALL"],["code"=>"PN","name"=>"ISOLE PITCAIRN"],["code"=>"SB","name"=>"ISOLE SALOMONE"],["code"=>"TF","name"=>"ISOLE SPARSE NELL'OCEANO INDIANO"],["code"=>"VI","name"=>"ISOLE VERGINI AMERICANE"],["code"=>"VG","name"=>"ISOLE VERGINI BRITANNICHE"],["code"=>"IL","name"=>"ISRAELE"],["code"=>"KZ","name"=>"KAZAKISTAN"],["code"=>"KE","name"=>"KENYA"],["code"=>"KG","name"=>"KIRGHIZISTAN"],["code"=>"KI","name"=>"KIRIBATI"],["code"=>"KW","name"=>"KUWAIT"],["code"=>"LA","name"=>"LAOS"],["code"=>"LS","name"=>"LESOTHO"],["code"=>"LV","name"=>"LETTONIA"],["code"=>"LB","name"=>"LIBANO"],["code"=>"LR","name"=>"LIBERIA"],["code"=>"LY","name"=>"LIBIA"],["code"=>"LI","name"=>"LIECHTENSTEIN"],["code"=>"LT","name"=>"LITUANIA"],["code"=>"LU","name"=>"LUSSEMBURGO"],["code"=>"MO","name"=>"MACAO"],["code"=>"MK","name"=>"MACEDONIA"],["code"=>"MG","name"=>"MADAGASCAR"],["code"=>"MW","name"=>"MALAWI"],["code"=>"MV","name"=>"MALDIVE"],["code"=>"MY","name"=>"MALESIA"],["code"=>"ML","name"=>"MALI"],["code"=>"MT","name"=>"MALTA"],["code"=>"MA","name"=>"MAROCCO"],["code"=>"MQ","name"=>"MARTINICA"],["code"=>"MR","name"=>"MAURITANIA"],["code"=>"MU","name"=>"MAURITIUS"],["code"=>"YT","name"=>"MAYOTTE"],["code"=>"MX","name"=>"MESSICO"],["code"=>"MD","name"=>"MOLDAVIA"],["code"=>"MN","name"=>"MONGOLIA"],["code"=>"ME","name"=>"MONTENEGRO"],["code"=>"MS","name"=>"MONTSERRAT"],["code"=>"MZ","name"=>"MOZAMBICO"],["code"=>"NA","name"=>"NAMIBIA"],["code"=>"NR","name"=>"NAURU"],["code"=>"NP","name"=>"NEPAL"],["code"=>"NI","name"=>"NICARAGUA"],["code"=>"NE","name"=>"NIGER"],["code"=>"NG","name"=>"NIGERIA"],["code"=>"NU","name"=>"NIUE"],["code"=>"NO","name"=>"NORVEGIA"],["code"=>"NC","name"=>"NUOVA CALEDONIA"],["code"=>"NZ","name"=>"NUOVA ZELANDA"],["code"=>"OM","name"=>"OMAN"],["code"=>"NL","name"=>"PAESI BASSI"],["code"=>"PK","name"=>"PAKISTAN"],["code"=>"PW","name"=>"PALAU"],["code"=>"PS","name"=>"PALESTINA"],["code"=>"PA","name"=>"PANAMA"],["code"=>"PG","name"=>"PAPUA NUOVA GUINEA"],["code"=>"PY","name"=>"PARAGUAY"],["code"=>"PE","name"=>"PERÃ™"],["code"=>"PF","name"=>"POLINESIA FRANCESE"],["code"=>"PL","name"=>"POLONIA"],["code"=>"PR","name"=>"PORTO RICO"],["code"=>"PT","name"=>"PORTOGALLO"],["code"=>"MC","name"=>"PRINCIPATO DI MONACO"],["code"=>"QA","name"=>"QATAR"],["code"=>"GB","name"=>"REGNO UNITO"],["code"=>"CZ","name"=>"REPUBBLICA CECA"],["code"=>"CF","name"=>"REPUBBLICA CENTRAFRICANA"],["code"=>"CG","name"=>"REPUBBLICA DEL CONGO"],["code"=>"CD","name"=>"REPUBBLICA DEMOCRATICA DEL CONGO"],["code"=>"DO","name"=>"REPUBBLICA DOMINICANA"],["code"=>"RE","name"=>"RIUNIONE"],["code"=>"RO","name"=>"ROMANIA"],["code"=>"RW","name"=>"RUANDA"],["code"=>"RU","name"=>"RUSSIA"],["code"=>"BQ","name"=>"SABA"],["code"=>"KN","name"=>"SAINT KITTS E NEVIS"],["code"=>"VC","name"=>"SAINT VINCENT E GRENADINE"],["code"=>"BL","name"=>"SAINT-BARTHÃ‰LEMY"],["code"=>"MF","name"=>"SAINT-MARTIN"],["code"=>"PM","name"=>"SAINT-PIERRE E MIQUELON"],["code"=>"WS","name"=>"SAMOA"],["code"=>"AS","name"=>"SAMOA AMERICANE"],["code"=>"SM","name"=>"SAN MARINO"],["code"=>"SH","name"=>"SANT'ELENA, ASCENSIONE E TRISTAN DA CUNHA"],["code"=>"LC","name"=>"SANTA LUCIA"],["code"=>"ST","name"=>"SÃO TOMÉ E PRÍNCIPE"],["code"=>"SN","name"=>"SENEGAL"],["code"=>"RS","name"=>"SERBIA"],["code"=>"SC","name"=>"SEYCHELLES"],["code"=>"SL","name"=>"SIERRA LEONE"],["code"=>"SG","name"=>"SINGAPORE"],["code"=>"BQ","name"=>"SINT EUSTATIUS"],["code"=>"SX","name"=>"SINT MAARTEN"],["code"=>"SY","name"=>"SIRIA"],["code"=>"SK","name"=>"SLOVACCHIA"],["code"=>"SI","name"=>"SLOVENIA"],["code"=>"SO","name"=>"SOMALIA"],["code"=>"ES","name"=>"SPAGNA"],["code"=>"LK","name"=>"SRI LANKA"],["code"=>"FM","name"=>"STATI FEDERATI DI MICRONESIA"],["code"=>"US","name"=>"STATI UNITI D'AMERICA"],["code"=>"ZA","name"=>"SUDAFRICA"],["code"=>"SD","name"=>"SUDAN"],["code"=>"SS","name"=>"SUDAN DEL SUD"],["code"=>"SR","name"=>"SURINAME"],["code"=>"SE","name"=>"SVEZIA"],["code"=>"CH","name"=>"SVIZZERA"],["code"=>"SZ","name"=>"SWAZILAND"],["code"=>"TJ","name"=>"TAGIKISTAN"],["code"=>"TW","name"=>"TAIWAN"],["code"=>"TZ","name"=>"TANZANIA"],["code"=>"TH","name"=>"THAILANDIA"],["code"=>"TL","name"=>"TIMOR EST"],["code"=>"TG","name"=>"TOGO"],["code"=>"TK","name"=>"TOKELAU"],["code"=>"TO","name"=>"TONGA"],["code"=>"TT","name"=>"TRINIDAD E TOBAGO"],["code"=>"TN","name"=>"TUNISIA"],["code"=>"TR","name"=>"TURCHIA"],["code"=>"TM","name"=>"TURKMENISTAN"],["code"=>"TC","name"=>"TURKS E CAICOS"],["code"=>"TV","name"=>"TUVALU"],["code"=>"UA","name"=>"UCRAINA"],["code"=>"UG","name"=>"UGANDA"],["code"=>"HU","name"=>"UNGHERIA"],["code"=>"UY","name"=>"URUGUAY"],["code"=>"UZ","name"=>"UZBEKISTAN"],["code"=>"VU","name"=>"VANUATU"],["code"=>"VE","name"=>"VENEZUELA"],["code"=>"VN","name"=>"VIETNAM"],["code"=>"WF","name"=>"WALLIS E FUTUNA"],["code"=>"YE","name"=>"YEMEN"],["code"=>"ZM","name"=>"ZAMBIA"],["code"=>"ZW","name"=>"ZIMBABWE"]];
	var $OPTIONAL_GROUPS = array
	(
		'special' => [ '13', '101' ],
		'children' => [ '7', '8', '9' ],
		'other' => []
	);
	
	var $STRINGS = array
	(
		'it' => array
		(
			'error' => 'Ci dispiace, sembra che il sito stia incontrando difficoltà tecniche. Prova a ricaricare la pagina o collegati di nuovo più tardi in caso che il problema persista.',
			
			'label_modify' => 'Modifica',
			'label_search' => 'Cerca',
			'label_select' => 'Seleziona…',
			
			'booking_coverage' => 'Copertura',
			'booking_coverage_deposit' => 'Cauzione da lasciare al banco',
			'booking_coverage_excess' => 'Franchigia da lasciare in caso di danni o furto',
			'booking_coverage_excess_damage' => 'Riduzione responsabilità economica per danni',
			'booking_coverage_excess_theft' => 'Riduzione responsabilità economica furto',
			'booking_coverage_view_terms' => 'Leggi le condizioni generali di noleggio per ulteriori info',
			'booking_date' => 'Quando e dove',
			'booking_error_email_not_valid' => 'L\'indirizzo email non sembra essere valido.',
			'booking_error_emails_not_equal' => 'Gli indirizzi email inseriti non sono uguali.',
			'booking_error_fill_form' => 'Bisogna compilare tutti i campi del form per procedere.',
			'booking_error_terms' => 'Bisogna accettare i termini e le condizioni di noleggio e il trattamento dei dati personali.',
			'booking_optionals' => 'Optional',
			'booking_optionals_next' => 'Continua',
			'booking_optionals_special' => 'Suggeriti per te',
			'booking_optionals_children' => 'Viaggiando con i bambini',
			'booking_optionals_other' => 'Optional aggiuntivi',
			'booking_optionals_totals' => 'Totale Noleggio',
			'booking_optionals_13' => 'Condividi il piacere della guida… Aggiungi uno o più conducenti al tuo noleggio e ognuno beneficerà della copertura per danni/furto del conducente principale.',
			'booking_optionals_101' => 'Noleggia un sistema di navigazione satellitare per avere a disposizione mappe aggiornate, notizie sul traffico in tempo reale, indicazioni su luoghi di interesse e navigazione audio in tutte le lingue europee più arabo, cinese, russo.',
			'booking_privacy' => 'trattamento dei propri dati personali',
			'booking_privacy_text' => 'Autorizzo al {privacy} secondo il D.LGS 196/2003 e successive modifiche.',
			'booking_quote' => 'Blocca prezzo a {totals}',
			'booking_reservation' => 'Prenota adesso',
			'booking_summary' => 'Riepilogo',
			'booking_terms' => 'i Termini e le Condizioni di noleggio',
			'booking_terms_text' => 'Desidero noleggiare il veicolo indicato secondo {terms} e alle tariffe in vigore. Ho ricevuto, letto ed accettato i Termini e le Condizioni di noleggio, tariffarie e assicurative.',
			'booking_totals' => 'Totale',
			'booking_totals_desc' => 'Totale noleggio',
			'booking_vehicle' => 'Veicolo',
			
			'checkout_base' => 'Località di ritiro',
			'checkout_base_select' => 'Seleziona la località di ritiro prima…',
			'checkout_date' => 'Data di ritiro',
			'checkin_base' => 'Località di consegna',
			'checkin_base_select' => 'Effettua la riconsegna in una località diversa',
			'checkin_date' => 'Data di riconsegna',
			
			'details_address' => 'Indirizzo e civico',
			'details_city' => 'Città',
			'details_country' => 'Nazione',
			'details_email' => 'Indirizzo email',
			'details_email_confirm' => 'Conferma indirizzo email',
			'details_name' => 'Nome',
			'details_phone' => 'Numero di telefono',
			'details_surname' => 'Cognome',
			'details_zip_code' => 'CAP',
			
			'format.datetime' => 'd-m-Y H:i',
			
			'month_0' => 'Gennaio',
			'month_1' => 'Febbraio',
			'month_2' => 'Marzo',
			'month_3' => 'Aprile',
			'month_4' => 'Maggio',
			'month_5' => 'Giugno',
			'month_6' => 'Luglio',
			'month_7' => 'Agosto',
			'month_8' => 'Settembre',
			'month_9' => 'Ottobre',
			'month_10' => 'Novembre',
			'month_11' => 'Dicembre',
			
			'param_big_bags' => 'Grande valige',			
			'param_doors' => 'Porte',
			'param_fuel_type_' => 'Alimentazione',
			'param_fuel_type_diesel' => 'Diesel',
			'param_fuel_type_electric' => 'Elettrica',
			'param_fuel_type_gpl' => 'GPL',
			'param_fuel_type_hybrid' => 'Ibrida',
			'param_fuel_type_methane' => 'Metano',
			'param_fuel_type_petrol' => 'Benzina',
			'param_gearshift_automatic' => 'Automatico',
			'param_gearshift_manual' => 'Manuale',
			'param_km_limit_none' => 'Km illimitati',
			'param_seats' => 'Posti',
			'param_small_bags' => 'Picc. valige',

			'results_checkout' => 'Ritiro',
			'results_checkin' => 'Riconsegna',
			'results_group_rate' => 'Da {rate}',
			'results_km_limit_day' => 'gg',
			'results_rate' => 'Prezzo',
			'results_rate_included' => 'Incluso',
			'results_remove' => 'Elimina',
			'results_select' => 'Scegli',
		)
	);
	
	function __construct()
	{
		$osd = isset($_POST['osd']) ? $_POST['osd'] : (isset($_GET['osd']) ? $_GET['osd'] : '');
		$siteUrl = get_site_url();

		define('_SG', 'OTABO:' . sha1($siteUrl));
		define('_SI', 'OTABO:' . sha1($siteUrl) . ($osd != '' ? '-' . $osd : ''));		

		define('OTABO_LANG', isset($_GET['otabo_lang']) && isset($this->STRINGS[$_GET['otabo_lang']]) ? $_GET['otabo_lang'] : array_shift(array_keys($this->STRINGS)));
		
		$appendix = ($osd != '' ? '?osd=' . $osd : '');

		define('OTABO_FORM_URL', get_page_link(get_option('form_url')) . $appendix);
		define('OTABO_RESULTS_URL', get_page_link(get_option('results_url')) . $appendix);
		define('OTABO_CONFIRM_URL', get_page_link(get_option('confirm_url')) . $appendix);

		if ($appendix != '')
		{
			$appendix .= isset($_GET['qid']) && $_GET['qid'] != '' ? '&qid=' . $_GET['qid'] : '';
			$appendix .= isset($_GET['cid']) && $_GET['cid'] != '' ? '&cid=' . $_GET['cid'] : '';
			$appendix .= isset($_GET['oid']) && $_GET['oid'] != '' ? '&oid=' . $_GET['oid'] : '';
		}

		define('OTABO_BOOKING_COVERAGES_URL', get_page_link(get_option('coverages_url')) . $appendix);
		define('OTABO_BOOKING_OPTIONALS_URL', get_page_link(get_option('optionals_url')) . $appendix);
		define('OTABO_BOOKING_URL', get_page_link(get_option('booking_url')) . $appendix);
	}
	
	function addScripts()
	{
		wp_enqueue_script('jquery');

		wp_register_script('otabo-script', plugins_url('/script.js', __FILE__), array(), '1.0');
		wp_enqueue_script('otabo-script');

		wp_register_style('otabo-style', plugins_url('/styles.css', __FILE__), array(), '1.0', 'all');
		wp_enqueue_style('otabo-style');
	}
	
	function ajax()
	{
		$error = NULL;
		$res = array('success' => false);
		
		$strings = $this->STRINGS[OTABO_LANG];//array_map(function($e) { return str_replace('\'', '\\\'', $e); }, $this->STRINGS[OTABO_LANG]);

		define('AUTH_ID', get_option('uuid'));
		define('AUTH_API_KEY', get_option('api_key'));
		
		if (isset($_POST['cmd']))
		{
			$wsdl = 'http://carrentalsoftware.myappy.it/web/ota/opentravel.wsdl';
// 			$wsdl = 'http://localhost/www.myappy.it/carrentalsoftware.myappy.it/web/ota/test.wsdl';
		
			try
			{
				///
				///
				// BASES LIST
				///
				///
				if ($_POST['cmd'] == 'bases')
				{
					$bases = NULL;
					if (isset($_SESSION[_SG]) && isset($_SESSION[_SG]['bases']) && count($_SESSION[_SG]['bases']) > 0)
					{
						$bases = $_SESSION[_SG]['bases'];
					}
					else
					{
						$xml = '
							<ns1:OTA_VehLocSearchRQ>
							  <POS>
								<Source>
								  <RequestorID Type="29" ID="' . AUTH_ID . '" MessagePassword="' . htmlspecialchars(AUTH_API_KEY) . '"><CompanyName>Comp</CompanyName></RequestorID>
								</Source>
							  </POS>
							</ns1:OTA_VehLocSearchRQ>';

						$client = new SoapClient($wsdl, array('trace' => 1, 'cache_wsdl' => WSDL_CACHE_NONE));
						$result = $client->OTA_VehLocSearch(new SoapVar($xml, XSD_ANYXML));

						$bases = array();
						if ($result && isset($result->Success) && $result->Success)
						{
							if (@count($result->VehMatchedLocs->VehMatchedLoc) > 1)
							{
								foreach ($result->VehMatchedLocs->VehMatchedLoc as $b)
								{
									$name = (string) $b->LocationDetail->Name;
									foreach ($bases as $k => $base)
									{
										if (strcasecmp($base['name'], $name) == 0)
										{
											$bases[$k]['uid'][] = (string) $b->LocationDetail->Code;
											$bases[$k]['uuid'][] = (string) $b->LocationDetail->ExtendedLocationCode;

											$b = NULL;
										}
									}
							
									if ($b)
									{
										$bases[] = array
										(
											'uid' => array((string) $b->LocationDetail->Code),
											'uuid' => array((string) $b->LocationDetail->ExtendedLocationCode),
											'name' => (string) $b->LocationDetail->Name
										);
									}
								}
							}
							else
							{
								$b = $result->VehMatchedLocs->VehMatchedLoc;
								$bases[] = array
								(
									'uid' => array((string) $b->LocationDetail->Code),
									'uuid' => array((string) $b->LocationDetail->ExtendedLocationCode),
									'name' => (string) $b->LocationDetail->Name
								);
							}
					
							usort($bases, function($lhs, $rhs) { return strcasecmp($lhs['name'], $rhs['name']); });
							for ($i = 0; $i < count($bases); $i++)
							{
								$bases[$i]['index'] = $i;
							}
						}
						else
						{
							$error = $this->printSoapError($client);
						}
					}
					
					if (isset($_SESSION[_SI]) && isset($_SESSION[_SI]['input']) && isset($_SESSION[_SI]['input']['ob'])
							&& isset($_SESSION[_SG]['bases'][$_SESSION[_SI]['input']['ob']]))
					{
						$res['checkout_base'] = $_SESSION[_SG]['bases'][$_SESSION[_SI]['input']['ob']];
					}

					if (isset($_SESSION[_SI]) && isset($_SESSION[_SI]['input']) && isset($_SESSION[_SI]['input']['ib'])
							&& isset($_SESSION[_SG]['bases'][$_SESSION[_SI]['input']['ib']]))
					{
						$res['checkin_base'] = $_SESSION[_SG]['bases'][$_SESSION[_SI]['input']['ib']];
					}
			
					if (isset($_SESSION[_SI]) && isset($_SESSION[_SI]['input']) && isset($_SESSION[_SI]['input']['ot']))
					{
						$res['checkout_time'] = $_SESSION[_SI]['input']['ot'];
					}

					if (isset($_SESSION[_SI]) && isset($_SESSION[_SI]['input']) && isset($_SESSION[_SI]['input']['it']))
					{
						$res['checkin_time'] = $_SESSION[_SI]['input']['it'];
					}
					
					if (!$error && $bases)
					{	
						if (count($bases) > 0)
						{
							$_SESSION[_SG]['bases'] = $bases;
						}

						$res['base'] = $bases;
						$res['success'] = TRUE;
					}
				}
				///
				///
				// RESULTS
				///
				///
				else if ($_POST['cmd'] == 'results'
						&& (isset($_POST['ob']) && isset($_POST['ot']) && isset($_POST['it'])
						|| isset($_SESSION[_SI]) && isset($_SESSION[_SI]['input']) && isset($_SESSION[_SI]['input']['ob'])
								&& isset($_SESSION[_SI]['input']['ot']) && isset($_SESSION[_SI]['input']['it'])))
				{
					if (!isset($_SESSION[_SG]) || !isset($_SESSION[_SG]['bases']))
					{
						$error = 'Error 24001: ' . _SG . '<pre>' . print_r($_SESSION, TRUE) . '</pre>';
					}
					else
					{
						$bases = $_SESSION[_SG]['bases'];

						if (isset($_SESSION[_SI]['quotes_result']) && (!isset($_POST['ob']) || $_SESSION[_SI]['input']['ob'] == $_POST['ob'])
								&& (!isset($_POST['ib']) || $_SESSION[_SI]['input']['ib'] == $_POST['ib'])
								&& (!isset($_POST['ot']) || $_SESSION[_SI]['input']['ot'] == $_POST['ot'])
								&& (!isset($_POST['it']) || $_SESSION[_SI]['input']['it'] == $_POST['it']))
						{
							$res['result'] = $_SESSION[_SI]['quotes_result'];
							$res['success'] = TRUE;
						}
						
						if (isset($_POST['ob']))
						{					
							$_SESSION[_SI]['input'] = $_POST;
						}							

						// Get the bases.
						$checkoutBase = isset($bases[$_SESSION[_SI]['input']['ob']]) ? $bases[$_SESSION[_SI]['input']['ob']] : NULL;
						$checkinBase = isset($_SESSION[_SI]['input']['ib']) && strlen($_SESSION[_SI]['input']['ib']) > 0 ? (isset($bases[$_SESSION[_SI]['input']['ib']]) ? $bases[$_SESSION[_SI]['input']['ib']] : NULL) :
								(isset($bases[$_SESSION[_SI]['input']['ob']]) ? $bases[$_SESSION[_SI]['input']['ob']] : NULL);
	
						if ($checkoutBase && $checkinBase && !isset($res['result']))
						{
							$input = array
							(
								'checkout_base' => $checkoutBase,
								'checkout_time' => $_SESSION[_SI]['input']['ot'],
								'checkin_base' => $checkinBase,
								'checkin_time' => $_SESSION[_SI]['input']['it'],
							);
							
							// Only consider companies that serve both bases.
							$checkoutBases = array();
							$checkinBases = array();

							for ($i = count($checkoutBase['uuid']) - 1; $i >= 0; $i--)
							{
								$uuid = $checkoutBase['uuid'][$i];
								$index = array_search($uuid, $checkinBase['uuid']);
							
								if ($index !== FALSE)
								{
									$checkoutBases[] = $checkoutBase['uid'][$i];
									$checkinBases[] = $checkinBase['uid'][$index];
								}
							}
						
							$xml = '
								<ns1:OTA_VehAvailRateRQ>
								  <POS>
									<Source>
									  <RequestorID Type="29" ID="' . AUTH_ID . '" MessagePassword="' . htmlspecialchars(AUTH_API_KEY) . '"><CompanyName>Comp</CompanyName></RequestorID>
									</Source>
								  </POS>
								  <VehAvailRQCore>
									<VehRentalCore PickUpDateTime="' . str_replace(' ', 'T', $_SESSION[_SI]['input']['ot']) . 'Z" '
											. 'ReturnDateTime="' . str_replace(' ', 'T', $_SESSION[_SI]['input']['it']) . 'Z">
									  <PickUpLocation LocationCode="' . implode(',', $checkoutBases) . '"/>
									  <ReturnLocation LocationCode="' . implode(',', $checkinBases) . '"/>
									</VehRentalCore>
								  </VehAvailRQCore>
								</ns1:OTA_VehAvailRateRQ>';

							$client = new SoapClient($wsdl, array('trace' => 1, 'cache_wsdl' => WSDL_CACHE_NONE));
							$result = $client->OTA_VehAvailRate(new SoapVar($xml, XSD_ANYXML));

							$quotes = array();
							$groups = array();

							if ($result && isset($result->Success) && $result->Success)
							{
								$cleanXml = str_ireplace(['SOAP-ENV:', 'SOAP:', 'ns1:'], '', $client->__getLastResponse());
								$xml = simplexml_load_string($cleanXml);
								$result = $xml->Body->OTA_VehAvailRateRS->VehAvailRSCore->VehVendorAvails;

								foreach ($result->VehVendorAvail as $vendorResult)
								{
									$vendor = NULL;
									if (isset($vendorResult->Vendor))
									{
										$vendor = array
										(
											'id' => (string) $vendorResult->Vendor['Code'],
											'name' => (string) $vendorResult->Vendor['CompanyShortName'],
											'logo' => (string) $vendorResult->Vendor['Logo'],
											'privacy_url' => (string) $vendorResult->Vendor->PrivacyDocument,
											'terms_url' => (string) $vendorResult->Vendor->TermsDocument
										);
									}
								
									if (!$vendorResult->VehAvails)
									{
										continue;
									}
								
									foreach ($vendorResult->VehAvails->VehAvail as $avail)
									{
										$charges = '';
										foreach ($avail->VehAvailCore->RentalRate->VehicleCharges->VehicleCharge as $charge)
										{
											$charges .= $charge->asXML();
										}
										
										$rate = (string) $avail->VehAvailCore->TotalCharge['EstimatedTotalAmount'];
										$quote = array
										(
											'acriss_code' => (string) $avail->VehAvailCore->Vehicle['Code'],
											'group' => $avail->VehAvailCore->Vehicle->VehType ?
													(string) $avail->VehAvailCore->Vehicle->VehType['VehicleCategory'] : 
													(string) $avail->VehAvailCore->Vehicle['Description'],
											'image' => (string) $avail->VehAvailCore->Vehicle->PictureURL,
											'name' => (string) $avail->VehAvailCore->Vehicle['Description'],
											'params' => $avail->VehAvailCore->Vehicle->VehType && $avail->VehAvailCore->Vehicle->VehType ?
													array_filter(array_map(function($e) { return isset($e['@attributes']) ? $e['@attributes'] : array(); }, json_decode(json_encode($avail->VehAvailCore->Vehicle->VehType), TRUE))) : array(),
											'rate' => sprintf('%.02f', $rate),
											'charge' => (string) $avail->VehAvailCore->TotalCharge['RateTotalAmount'],
											'charges' => implode('', array_map('trim', explode("\n", $charges))),
											'vendor' => $vendor,
											'coverages' => array(),
											'optionals' => array(),
										);
									
										if ($avail->VehAvailCore->RentalRate
												&& $avail->VehAvailCore->RentalRate->RateDistance
												&& $avail->VehAvailCore->RentalRate->RateDistance['Unlimited'] == 'false')
										{
											$quote['km_limit'] = (string) $avail->VehAvailCore->RentalRate->RateDistance['Quantity'];
											$quote['km_limit_period'] = $strings['results_km_limit_' . strtolower((string) $avail->VehAvailCore->RentalRate->RateDistance['VehiclePeriodUnitName'])];
										}

										if ($avail->VehAvailCore->PricedEquips)
										{
											foreach ($avail->VehAvailCore->PricedEquips->PricedEquip as $optional)
											{
												if ($optional->Equipment && $optional->Equipment['EquipType'] && (string) $optional->Equipment['EquipType'] != '39')
												{
													if (!$optional->Charge)
													{
														continue;
													}
												
													$rate = (string) $optional->Charge['Amount'];
													if ($optional->Charge->TaxAmounts)
													{
														foreach ($optional->Charge->TaxAmounts->TaxAmount as $tax)
														{
															$rate += (string) $tax['Total'];
														}
													}
												
													$charges = '<VehicleCharge Purpose="21" '
															. 'Description="' . htmlspecialchars((string) $optional->Equipment->Description) . '" '
															. 'IncludedInEstTotalInd="true" '
															. 'IncludedInRate="false" '
															. 'TaxInclusive="false" '
															. 'Amount="' . htmlspecialchars((string) $optional->Charge['Amount']) . '" '
															. 'CurrencyCode="EUR">' . $optional->Charge->TaxAmounts->asXML() . '</VehicleCharge>';
															
													$quote['optionals'][] = array
													(
														'id' => (string) $optional->Equipment['EquipType'],
														'name' => (string) $optional->Equipment->Description,
														'rate' => sprintf('%.02f', $rate),
														'charges' => implode('', array_map('trim', explode("\n", $charges))),
													);
												}
											}											
										}
									
										if ($avail->VehAvailInfo && $avail->VehAvailInfo->PricedCoverages)
										{
											foreach ($avail->VehAvailInfo->PricedCoverages->PricedCoverage as $coverage)
											{
												if ($coverage->Coverage && $coverage->Coverage['CoverageType'] && (string) $coverage->Coverage['CoverageType'] == '21')
												{
													if (!$coverage->Charge)
													{
														continue;
													}
												
													$rate = (string) $coverage->Charge['Amount'];
													if ($coverage->Charge->TaxAmounts)
													{
														foreach ($coverage->Charge->TaxAmounts->TaxAmount as $tax)
														{
															$rate += (string) $tax['Total'];
														}
													}
													
													$charges = '<VehicleCharge Purpose="4" '
															. 'Description="' . htmlspecialchars((string) $coverage->Coverage->Details['CoverageTextType']) . '" '
															. 'IncludedInEstTotalInd="true" '
															. 'IncludedInRate="false" '
															. 'TaxInclusive="false" '
															. 'Amount="' . htmlspecialchars((string) $coverage->Charge['Amount']) . '" '
															. 'CurrencyCode="EUR">' . $coverage->Charge->TaxAmounts->asXML() . '</VehicleCharge>';
												
													$quote['coverages'][] = array
													(
														'id' => (string) $coverage->Coverage['Code'],
														'name' => (string) $coverage->Coverage->Details['CoverageTextType'],
														'rate' => sprintf('%.02f', $rate),
														'charges' => implode('', array_map('trim', explode("\n", $charges))),
														'deposit' => (string) $coverage->Coverage['Deposit'],
														'excess' => isset($coverage->Deductible['Amount']) ? (string) $coverage->Deductible['Amoun'] : NULL,
														'excess_damage' => isset($coverage->Deductible['ExcessDamage']) ? (string) $coverage->Deductible['ExcessDamage'] : NULL,
														'excess_info' => isset($coverage->Deductible['ExcessInfo']) ? (string) $coverage->Deductible['ExcessInfo'] : NULL,
														'excess_theft' => isset($coverage->Deductible['ExcessTheft']) ? (string) $coverage->Deductible['ExcessTheft'] : NULL,
													);
												}
											}											
										}

										$quotes[] = $quote;
										
										if (!isset($groups[$quote['group']]))
										{
											$groups[$quote['group']] = array
											(
												'min' => $quote['rate'],
												'name' => $quote['group']
											);
										}
										
										if (!isset($groups[$quote['group']]['image']) && isset($quote['image']) && strlen($quote['image']) > 0)
										{
											$groups[$quote['group']]['image'] = $quote['image'];
										}
										
										if ($groups[$quote['group']]['min'] > $quote['rate'])
										{
											$groups[$quote['group']]['min'] = $quote['rate'];
										}
									}
								}
								
								$thisGroups = array();
								foreach ($groups as $k => $v)
								{
									$v['name'] = $k;
									$thisGroups[] = $v;
								}
								
								$groups = $thisGroups;
								usort($groups, function($lhs, $rhs)
								{
									$res = (isset($lhs['min']) ? $lhs['min'] : 0) - (isset($rhs['min']) ? $rhs['min'] : 0);
									if ($res == 0)
									{
										$res = strcasecmp($lhs['name'], $rhs['name']);
									}
									
									return $res;
								});
								
								usort($quotes, function($lhs, $rhs)
								{
									return $lhs['rate'] == $rhs['rate'] ?
											strcasecmp($lhs['group'], $rhs['group']) :
											$lhs['rate'] - $rhs['rate'];
								});
								
								foreach ($quotes as $k => $v)
								{
									$quotes[$k]['id'] = $k;
								}

								$res['result'] = array('quotes' => $quotes, 'groups' => $groups, 'input' => $input);
								$res['success'] = TRUE;
								
								$_SESSION[_SI]['quotes_result'] = $res['result'];
							}
							else
							{
								$error = 'Error 24002 - ' . $result->Errors->Error;
							}				
						}
						else if (!isset($res['result']))
						{
							$error = 'Error 24003 - ' . $_POST['ob'] . ' :: ' . (isset($_POST['ib']) ? $_POST['ib'] : 'NA');
						}
					}
				}
				///
				///
				// SUBMISSION
				///
				///
				else if ($_POST['cmd'] == 'submit' && (isset($_POST['quote']) && ($quote = json_decode(stripcslashes($_POST['quote']), TRUE)) != NULL)
						&& isset($_SESSION[_SI]) && isset($_SESSION[_SI]['input']) && isset($_SESSION[_SI]['input']['ob'])
						&& isset($_SESSION[_SI]['input']['ot']) && isset($_SESSION[_SI]['input']['it']))
				{
					if (!isset($_SESSION[_SG]) || !isset($_SESSION[_SG]['bases']))
					{
						$error = 'Error 25001: ' . _SG . '<pre>' . print_r($_SESSION, TRUE) . '</pre>';
					}
					else
					{
						// Get the bases.
						$bases = $_SESSION[_SG]['bases'];
						$checkoutBase = isset($bases[$_SESSION[_SI]['input']['ob']]) ? $bases[$_SESSION[_SI]['input']['ob']] : NULL;
						$checkinBase = isset($_SESSION[_SI]['input']['ib']) && strlen($_SESSION[_SI]['input']['ib']) > 0 ? (isset($bases[$_SESSION[_SI]['input']['ib']]) ? $bases[$_SESSION[_SI]['input']['ib']] : NULL) :
								(isset($bases[$_SESSION[_SI]['input']['ob']]) ? $bases[$_SESSION[_SI]['input']['ob']] : NULL);
	
						if (!$error && $checkoutBase && $checkinBase && !isset($res['result']))
						{
							$input = array
							(
								'checkout_base' => $checkoutBase,
								'checkout_time' => $_SESSION[_SI]['input']['ot'],
								'checkin_base' => $checkinBase,
								'checkin_time' => $_SESSION[_SI]['input']['it'],
							);

							// Only consider companies that serve both bases.
							$checkoutBases = array();
							$checkinBases = array();

							for ($i = count($checkoutBase['uuid']) - 1; $i >= 0; $i--)
							{
								$uuid = $checkoutBase['uuid'][$i];
								$index = array_search($uuid, $checkinBase['uuid']);
							
								if ($index !== FALSE)
								{
									$checkoutBases[] = $checkoutBase['uid'][$i];
									$checkinBases[] = $checkinBase['uid'][$index];
								}
							}
						
							$xml = '
								<ns1:OTA_VehResRQ>
									<POS>
										<Source>
											<RequestorID Type="29" ID="' . (isset($quote['vendor']) ? $quote['vendor']['id'] : AUTH_ID) . '" MessagePassword="' . htmlspecialchars(AUTH_API_KEY) . '"><CompanyName>Comp</CompanyName></RequestorID>
										</Source>
									</POS>
									<VehResRQCore>
										<VehRentalCore PickUpDateTime="' . str_replace(' ', 'T', $_SESSION[_SI]['input']['ot']) . 'Z" '
												. 'ReturnDateTime="' . str_replace(' ', 'T', $_SESSION[_SI]['input']['it']) . 'Z">
											<PickUpLocation LocationCode="' . implode(',', $checkoutBases) . '"/>
											<ReturnLocation LocationCode="' . implode(',', $checkinBases) . '"/>
										</VehRentalCore>
										<VehPref>
											<VehMakeModel Code="' . htmlspecialchars($quote['acriss_code']) . '"/>
										</VehPref>
										<Customer>
											<Primary>
												<PersonName>
													<GivenName>' . htmlspecialchars($quote['client']['name']) . '</GivenName>
													<Surname>' . htmlspecialchars($quote['client']['surname']) . '</Surname>
												</PersonName>
												<Telephone PhoneNumber="' . htmlspecialchars($quote['client']['phone']) . '" />
												<Email>' . htmlspecialchars($quote['client']['email']) . '</Email>
												<Address>
													<AddressLine>' . htmlspecialchars($quote['client']['address']) . '</AddressLine>
													<CityName>' . htmlspecialchars($quote['client']['city']) . '</CityName>
													<CountryName>' . htmlspecialchars($quote['client']['country']) . '</CountryName>
													<PostalCode>' . htmlspecialchars($quote['client']['zip_code']) . '</PostalCode>
												</Address>
											</Primary>
										</Customer>
										<VehicleCharges>
											' . $quote['charges'] . '
											' . (isset($quote['coverage']) ? $quote['coverage']['charges'] : '') . '
											' . (isset($quote['optionals']) ? array_reduce($quote['optionals'], function($s, $e) { return $s . $e['charges']; }, '') : '') . '
										</VehicleCharges>
										' . (isset($quote['optionals']) ?
											'<SpecialEquipPrefs>
												' . array_reduce($quote['optionals'], function($s, $e) { return $s . '<SpecialEquipPref EquipType="' . htmlspecialchars($e['id']) . '" />'; }, '') . '
											</SpecialEquipPrefs>' : '') . '
										<TotalCharge CurrencyCode="EUR" RateTotalAmount="' . htmlspecialchars($quote['charge']) . '"
												EstimatedTotalAmount="' . ($quote['rate'] + (isset($quote['coverage']) ? $quote['coverage']['rate'] : 0)
														+ (isset($quote['optionals']) ? array_reduce($quote['optionals'], function($s, $e) { return $s + $e['rate']; }, 0) : 0)) . '" />
									</VehResRQCore>
									<VehResRQInfo>
										' . (isset($quote['coverage']) ?
											'<CoveragePrefs>
												<CoveragePref Code="' . htmlspecialchars($quote['coverage']['id']) . '" CoverageType="21"/>
											</CoveragePrefs>' : '') . '
									</VehResRQInfo>
								</ns1:OTA_VehResRQ>';

							$client = new SoapClient($wsdl, array('trace' => 1, 'cache_wsdl' => WSDL_CACHE_NONE));
							$result = $client->OTA_VehRes(new SoapVar($xml, XSD_ANYXML));

							if ($result && isset($result->Success) && $result->Success)
							{
								$cleanXml = str_ireplace(['SOAP-ENV:', 'SOAP:', 'ns1:'], '', $client->__getLastResponse());
								$xml = simplexml_load_string($cleanXml);
								$result = $xml->Body->OTA_VehResRS->VehResRSCore->VehReservation;
								
								unset($_SESSION[_SI]['quotes_result']);

								$key = $result['ReservationStatus'] && $result['ReservationStatus'] == 'Requested' ? 'quote' : 'reservation';
								$_SESSION[_SI][$key] = array();
								foreach ($result->VehSegmentCore->ConfID as $k => $v)
								{
									if ($v['Type'] && $v['Type'] == 16)
									{
										$_SESSION[_SI][$key]['uid'] = (string) $v['ID'];
									}
									else if ($v['Type'] && $v['Type'] == 23)
									{
										$_SESSION[_SI][$key]['ref_id'] = (string) $v['ID'];
									}
								}
								
								$res['result'] = $_SESSION[_SI][$key];
								$res['success'] = TRUE;
							}
							else
							{
								$error = 'Error 25002 - ' . print_r($result->Errors, TRUE);

								$dom = new DOMDocument();
								$dom->preserveWhiteSpace = false;
								$dom->formatOutput = true;
								$dom->loadXML($client->__getLastRequest());
								$error .= '<pre>' . $dom->saveXML() . '</pre>';

								$dom = new DOMDocument();
								$dom->preserveWhiteSpace = false;
								$dom->formatOutput = true;
								$dom->loadXML($client->__getLastResponse());
								$error .= '<pre>' . $dom->saveXML() . '</pre>';
							}				
						}
						else if (!$error)
						{
							$error = 'Error 25003 - ' . $_POST['ob'] . ' :: ' . (isset($_POST['ib']) ? $_POST['ib'] : 'NA');
						}
					}
				}
				else
				{
					$error = 'Error 20000' . '<pre>' . print_r($_POST, TRUE) . '</pre>' . '<pre>' . json_last_error_msg() . '</pre>';
				}
			}
			catch (Exception $e)
			{
				$dom = new DOMDocument();
				$dom->preserveWhiteSpace = false;
				$dom->formatOutput = true;
				$dom->loadXML($client->__getLastResponse());
				echo $dom->saveXML();

				$error = 'Error 20001' . '<pre>' . print_r($client->__getLastResponse(), TRUE) . "\n\n" . print_r($e, TRUE) . '</pre>';
			}
		}
		else
		{
			$error = 'Error 200002';
		}
		
		if ($error)
		{
			$res = array('error' => $error, 'success' => FALSE);
		}
		
		die(json_encode($res));
	}
	
	function postBookingCoverages($attr)
	{
		$strings = array_map(function($e) { return str_replace('\'', '\\\'', $e); }, $this->STRINGS[OTABO_LANG]);

		$quote = isset($_SESSION[_SI]) && isset($_SESSION[_SI]['quotes_result']) && isset($_SESSION[_SI]['quotes_result']['quotes'])
				&& array_key_exists('qid', $_GET) && isset($_SESSION[_SI]['quotes_result']['quotes'][$_GET['qid']]) ? $_SESSION[_SI]['quotes_result']['quotes'][$_GET['qid']] : NULL;
		if (!$quote)
		{
			return '<script>window.location = \'' . (isset($_SESSION['quotes_result']) ? OTABO_RESULTS_URL : OTABO_FORM_URL) . '\'; </script>';
		}

		$form = '

		<div class="otabo">
			<script>
				
				var _S = ' . json_encode($strings) . ';
				jQuery(function( $ )
				{
					OTABO_GW_URL = \'' . admin_url('admin-ajax.php') . '\';
					OTABO_IMG_DIR = \'' . plugin_dir_url(__FILE__) . 'images/\';
					OTABO_LANG = \'' . OTABO_LANG . '\';

					OTABO_BOOKING_COVERAGES_URL = \'' . OTABO_BOOKING_COVERAGES_URL . '\'
					OTABO_BOOKING_OPTIONALS_URL = \'' . OTABO_BOOKING_OPTIONALS_URL . '\'
					OTABO_BOOKING_URL = \'' . OTABO_BOOKING_URL . '\'
					OTABO_CONFIRM_URL = \'' . OTABO_CONFIRM_URL . '\'
					OTABO_FORM_URL = \'' . OTABO_FORM_URL . '\'
					OTABO_RESULTS_URL = \'' . OTABO_RESULTS_URL . '\'
					
					OTABO_TERMS_URL = \'' . get_option('terms_url') . '\';
					
					otaboLoadBookingCoverages(' . json_encode($quote) . ', '
							. json_encode(isset($_GET['cid']) ? '' . $_GET['cid'] : NULL) . ');
				});
				
			</script>
			
			<div id="otabo_coverages">
			</div>

		</div>';
		
		return $form;
	}
	
	function postBookingDetails($attr)
	{
		$strings = array_map(function($e) { return str_replace('\'', '\\\'', $e); }, $this->STRINGS[OTABO_LANG]);

		$quote = isset($_SESSION[_SI]) && isset($_SESSION[_SI]['quotes_result']) && isset($_SESSION[_SI]['quotes_result']['quotes'])
				&& array_key_exists('qid', $_GET) && isset($_SESSION[_SI]['quotes_result']['quotes'][$_GET['qid']]) ? $_SESSION[_SI]['quotes_result']['quotes'][$_GET['qid']] : NULL;
		if (!$quote)
		{
			return '<script>window.location = \'' . (isset($_SESSION['quotes_result']) ? OTABO_RESULTS_URL : OTABO_FORM_URL) . '\'; </script>';
		}
		
		$totals = $quote['rate'];

		// Got any coverages?
		if (isset($_GET['cid']) && $_GET['cid'] != '')
		{
			$totals += $quote['coverages'][$_GET['cid']]['rate'];
		}
		
		foreach (explode(',', $_GET['oid']) AS $o)
		{
			$totals += $quote['optionals'][$o]['rate'];
		}
				
		$fields = '';
		foreach (array('name', 'surname', 'email', 'email_confirm', 'phone', 'address', 'city', 'zip_code') as $field)
		{
			$fields .= '<label for="otabo_' . $field . '">' . $strings['details_' . $field] . '</label>'
					. '<input type="text" name="otabo_' . $field . '" id="otabo_' . $field . '" />';
		}
		
		$fields .= '<label for="otabo_country">' . $strings['details_country'] . '</label>'
				. '<div class="input">
					<input type="text" id="otabo_country" />
					<ul id="otabo_country_list">
					</ul>
				</div>';
				
		$privacy = isset($quote['vendor']) ? $quote['vendor']['privacy_url'] : get_option('privacy_url');
		$privacy = $privacy && strlen($privacy) > 0 ? '<a target="_blank" href="' . $privacy . '">' . $strings['booking_privacy'] . '</a>' : $strings['booking_privacy'];
		$privacy = str_replace('{privacy}', $privacy, $strings['booking_privacy_text']);

		$terms = isset($quote['vendor']) ? $quote['vendor']['terms_url'] : get_option('terms_url');
		$terms = $terms && strlen($terms) > 0 ? '<a target="_blank" href="' . $terms . '">' . $strings['booking_terms'] . '</a>' : $strings['booking_terms'];
		$terms = str_replace('{terms}', $terms, $strings['booking_terms_text']);

		$form = '

		<div class="otabo">
			<script>
				
				var _S = ' . json_encode($strings) . ';
				jQuery(function( $ )
				{
					OTABO_GW_URL = \'' . admin_url('admin-ajax.php') . '\';
					OTABO_IMG_DIR = \'' . plugin_dir_url(__FILE__) . 'images/\';
					OTABO_LANG = \'' . OTABO_LANG . '\';

					OTABO_BOOKING_COVERAGES_URL = \'' . OTABO_BOOKING_COVERAGES_URL . '\'
					OTABO_BOOKING_OPTIONALS_URL = \'' . OTABO_BOOKING_OPTIONALS_URL . '\'
					OTABO_BOOKING_URL = \'' . OTABO_BOOKING_URL . '\'
					OTABO_CONFIRM_URL = \'' . OTABO_CONFIRM_URL . '\'
					OTABO_FORM_URL = \'' . OTABO_FORM_URL . '\'
					OTABO_RESULTS_URL = \'' . OTABO_RESULTS_URL . '\'
					
					document.getElementById(\'otabo_submit\').innerHTML = _S.booking_quote.replace(\'{totals}\', otaboFormatCurrency(' . $totals . '));
					otaboLoadBookingDetails(' . json_encode($_GET['osd']) . ', ' . json_encode($quote) . ', '
							. json_encode(isset($_GET['cid']) && $_GET['cid'] != '' ? $_GET['cid'] : NULL) . ', '
							. json_encode(isset($_GET['oid']) ? '' . $_GET['oid'] : NULL) . ', '
							. json_encode($this->COUNTRIES) . ');
				});
				
			</script>
			
			<div id="otabo_booking">
				<fieldset id="otabo_booking_form">
					' . $fields . '

					<div class="input">
						<input id="otabo_terms" type="checkbox" /><span>' . $terms . '</span>
					</div>
					<div class="input">
						<input id="otabo_privacy" type="checkbox" /><span>' . $privacy . '</span>
					</div>

					<div id="otabo_error">
						<p id="otabo_error_msg"></p>
					</div>
					
					<button id="otabo_submit">' . $strings['booking_quote'] . '</button>
				</fieldset>
				
				<div class="loading" id="otabo_loading">
					<img class="loading_1" src="' . plugin_dir_url(__FILE__) . 'images/loading_dot.png" />
					<img class="loading_2" src="' . plugin_dir_url(__FILE__) . 'images/loading_dot.png" />
					<img class="loading_3" src="' . plugin_dir_url(__FILE__) . 'images/loading_dot.png" />
				</div>
			</div>
			
		</div>';
		
		return $form;
	}
	
	function postBookingNo($attr)
	{
		$strings = array_map(function($e) { return str_replace('\'', '\\\'', $e); }, $this->STRINGS[OTABO_LANG]);

		$data = isset($_SESSION[_SI]) && isset($_SESSION[_SI]['quote']) && isset($_SESSION[_SI]['quote']['ref_id']) ? $_SESSION[_SI]['quote'] :
				(isset($_SESSION[_SI]) && isset($_SESSION[_SI]['reservation']) && isset($_SESSION[_SI]['reservation']['ref_id']) ? $_SESSION[_SI]['reservation'] : NULL);
		if (!$data)
		{
			return '<script>window.location = \'' . (isset($_SESSION['quotes_result']) ? OTABO_RESULTS_URL : OTABO_FORM_URL) . '\'; </script>';
		}

		return $data['ref_id'];
	}
	
	function postBookingOptionals($attr)
	{
		$strings = array_map(function($e) { return str_replace('\'', '\\\'', $e); }, $this->STRINGS[OTABO_LANG]);

		$quote = isset($_SESSION[_SI]) && isset($_SESSION[_SI]['quotes_result']) && isset($_SESSION[_SI]['quotes_result']['quotes'])
				&& array_key_exists('qid', $_GET) && isset($_SESSION[_SI]['quotes_result']['quotes'][$_GET['qid']]) ? $_SESSION[_SI]['quotes_result']['quotes'][$_GET['qid']] : NULL;
		if (!$quote)
		{
			return '<script>window.location = \'' . (isset($_SESSION['quotes_result']) ? OTABO_RESULTS_URL : OTABO_FORM_URL) . '\'; </script>';
		}

		$form = '

		<div class="otabo">
			<script>
				
				var _S = ' . json_encode($strings) . ';
				jQuery(function( $ )
				{
					OTABO_GW_URL = \'' . admin_url('admin-ajax.php') . '\';
					OTABO_IMG_DIR = \'' . plugin_dir_url(__FILE__) . 'images/\';
					OTABO_LANG = \'' . OTABO_LANG . '\';

					OTABO_BOOKING_COVERAGES_URL = \'' . OTABO_BOOKING_COVERAGES_URL . '\'
					OTABO_BOOKING_OPTIONALS_URL = \'' . OTABO_BOOKING_OPTIONALS_URL . '\'
					OTABO_BOOKING_URL = \'' . OTABO_BOOKING_URL . '\'
					OTABO_CONFIRM_URL = \'' . OTABO_CONFIRM_URL . '\'
					OTABO_FORM_URL = \'' . OTABO_FORM_URL . '\'
					OTABO_RESULTS_URL = \'' . OTABO_RESULTS_URL . '\'
					
					otaboLoadBookingOptionals(' . json_encode($quote) . ', '
							. json_encode(isset($_GET['cid']) && $_GET['cid'] != '' ? $_GET['cid'] : NULL) . ', '
							. json_encode($this->OPTIONAL_GROUPS) . ', '
							. json_encode(isset($_GET['oid']) ? '' . $_GET['oid'] : NULL) . ');
				});
				
			</script>
			
			<div id="otabo_optionals">
			</div>
			
		</div>';
		
		return $form;
	}
	
	function postBookingSummary($attr)
	{
		$strings = $this->STRINGS[OTABO_LANG];

		$quote = isset($_SESSION[_SI]) && isset($_SESSION[_SI]['quotes_result']) && isset($_SESSION[_SI]['quotes_result']['quotes'])
				&& array_key_exists('qid', $_GET) && isset($_SESSION[_SI]['quotes_result']['quotes'][$_GET['qid']]) ? $_SESSION[_SI]['quotes_result']['quotes'][$_GET['qid']] : NULL;
		if (!$quote)
		{
			return '';
		}

		$bases = $_SESSION[_SG]['bases'];
		$input = $_SESSION[_SI]['input'];

		$checkoutBase = isset($bases[$input['ob']]) ? $bases[$input['ob']] : NULL;
		$checkinBase = isset($input['ib']) && strlen($input['ib']) > 0 ? (isset($bases[$input['ib']]) ? $bases[$input['ib']] : NULL) : $checkoutBase;

		$totals = $quote['rate'];

		// Got any coverages?
		$coverage = '';
		if (isset($_GET['cid']) && $_GET['cid'] != '')
		{
			$totals += $quote['coverages'][$_GET['cid']]['rate'];
			$coverage .= '<ul>
					<li>
						<span class="input">' . $strings['booking_coverage'] . ' <a id="otabo_coverage_modify" href="' . OTABO_BOOKING_COVERAGES_URL . '">[' . strtolower($strings['label_modify']) . ']</a>' . '</span>
						<span class="coverage">
							<table>
								<tr>
									<td>' . $quote['coverages'][$_GET['cid']]['name'] . '</td>
									<td id="otabo_coverage_rate" class="rate"></td>
								</tr>
							</table>
						</span>
						<span id="otabo_coverage_rate" class="rate"></span>
					</li>
				</ul>';
		}
		
		// Got any optionals?
		$optionalsLoading = '';
		$optionalsStr = '';
		$optionalsTotals = 0;

		if (isset($_GET['oid']) && $_GET['oid'] != '')
		{
			foreach (explode(',', $_GET['oid']) AS $o)
			{
				$optionalsLoading .= 'document.getElementById(\'otabo_optionals_rate_' . $o . '\').innerHTML = otaboFormatCurrency(\'' . $quote['optionals'][$o]['rate'] . '\');';
				$optionalsStr .= '<span class="optionals"><table><tr><td>' . $quote['optionals'][$o]['name'] . '</td>'
						. '<td class="rate" id="otabo_optionals_rate_' . $o . '"></td></tr></table></span>';
				$optionalsTotals += $quote['optionals'][$o]['rate'];
			}
			
			$totals += $optionalsTotals;
		}
		
		$optionals = '<ul id="otabo_optionals_holder"' . ($optionalsStr == '' ? ' style="display: none"' : '') . '>
					<li id="otabo_optionals_list">
						<span class="input">' . $strings['booking_optionals'] . ' <a href="' . OTABO_BOOKING_OPTIONALS_URL . '">[' . strtolower($strings['label_modify']) . ']</a>' . '</span>
						' . $optionalsStr . '
					</li>
				</ul>';
				
		$sumTotals = '<ul id="otabo_totals_holder"' . ($optionalTotals > 0 || $coverage != '' ? '' : ' style="display: none"') . '>
					<li>
						<span class="input">' . $strings['booking_totals'] . '</span>
						<span class="totals">
							<table>
								<tr>
									<td>' . $strings['booking_totals_desc'] . '</td>
									<td id="otabo_totals" class="rate"></td>
								</tr>
							</table>
						</span>
					</li>
				</ul>';

		$form = '

		<div class="otabo">
			<script>
				
				var _S = ' . json_encode($strings) . ';
				jQuery(function( $ )
				{
					OTABO_GW_URL = \'' . admin_url('admin-ajax.php') . '\';
					OTABO_IMG_DIR = \'' . plugin_dir_url(__FILE__) . 'images/\';
					OTABO_LANG = \'' . OTABO_LANG . '\';

					OTABO_BOOKING_COVERAGES_URL = \'' . OTABO_BOOKING_COVERAGES_URL . '\'
					OTABO_BOOKING_OPTIONALS_URL = \'' . OTABO_BOOKING_OPTIONALS_URL . '\'
					OTABO_BOOKING_URL = \'' . OTABO_BOOKING_URL . '\'
					OTABO_CONFIRM_URL = \'' . OTABO_CONFIRM_URL . '\'
					OTABO_FORM_URL = \'' . OTABO_FORM_URL . '\'
					OTABO_RESULTS_URL = \'' . OTABO_RESULTS_URL . '\'
					
					document.getElementById(\'otabo_checkout_time\').innerHTML = otaboFormatDate(\'' . $input['ot'] . '\');
					document.getElementById(\'otabo_checkin_time\').innerHTML = otaboFormatDate(\'' . $input['it'] . '\');
					document.getElementById(\'otabo_quote_rate\').innerHTML = otaboFormatCurrency(\'' . $quote['rate'] . '\');
					' . $optionalsLoading . '
					
					var e = document.getElementById(\'otabo_coverage_rate\');
					if (e)
					{
						e.innerHTML = otaboFormatCurrency(\'' . $quote['coverages'][$_GET['cid']]['rate'] . '\');
					}

					var e = document.getElementById(\'otabo_optionals_rate\');
					if (e && ' . $optionalsTotals . ' > 0)
					{
						document.getElementById(\'otabo_optionals_rate_holder\').style.display = \'block\';
						e.innerHTML = otaboFormatCurrency(\'' . $optionalsTotals . '\');
					}
					
					var e = document.getElementById(\'otabo_totals\');
					if (e)
					{
						e.innerHTML = otaboFormatCurrency(\'' . $totals . '\');
					}
				});
				
			</script>
			
			<div id="otabo_booking_header">
				<span class="summary">' . $strings['booking_summary'] . '</span>
				<ul>
					<li>
						<span class="input">' . $strings['booking_date'] . ' <a href="' . OTABO_FORM_URL . '">[' . strtolower($strings['label_modify']) . ']</a>' . '</span>
						<span class="base">' . $checkoutBase['name'] . '<span class="date" id="otabo_checkout_time"></span></span>
					</li><li>
						<span class="base">' . $checkoutBase['name'] . '<span class="date" id="otabo_checkin_time"></span></span>
					</li>
				</ul>
				<ul>
					<li>
						<span class="input">' . $strings['booking_vehicle'] . ' <a href="' . OTABO_RESULTS_URL . '">[' . strtolower($strings['label_modify']) . ']</a>' . '</span>
						<span class="vehicle">
							<table>
								<tr>
									<td>' . $quote['group'] . ($quote['name'] != $quote['group'] ? '<br />' . $quote['name'] : '') . '</td>
									<td id="otabo_quote_rate" class="rate"></td>
								</tr>
							</table>
						</span>
					</li>
				</ul>
				' . $coverage . '
				' . $optionals . '
				' . $sumTotals . '
				' . (get_permalink() != get_page_link(get_option('booking_url')) ? 
						'<a href="' . OTABO_BOOKING_URL . '"><button>Checkout</button></a>' : '') . '
			</div>

		</div>';
		
		return $form;
	}

	function postForm($attr)
	{
		$strings = array_map(function($e) { return str_replace('\'', '\\\'', $e); }, $this->STRINGS[OTABO_LANG]);
		
		$osd = isset($_GET['osd']) ? $_GET['osd'] : sha1(rand() * time());
		
		$form = '
		
		<div class="otabo">
			<script>
				
				var _S = ' . json_encode($strings) . ';
				jQuery(function( $ )
				{
					OTABO_GW_URL = \'' . admin_url('admin-ajax.php') . '\';
					OTABO_IMG_DIR = \'' . plugin_dir_url(__FILE__) . 'images/\';
					OTABO_LANG = \'' . OTABO_LANG . '\';
					OTABO_OSD = \'' . $osd . '\';

					OTABO_BOOKING_COVERAGES_URL = \'' . OTABO_BOOKING_COVERAGES_URL . '\'
					OTABO_BOOKING_OPTIONALS_URL = \'' . OTABO_BOOKING_OPTIONALS_URL . '\'
					OTABO_BOOKING_URL = \'' . OTABO_BOOKING_URL . '\'
					OTABO_CONFIRM_URL = \'' . OTABO_CONFIRM_URL . '\'
					OTABO_FORM_URL = \'' . OTABO_FORM_URL . '\'
					OTABO_RESULTS_URL = \'' . OTABO_RESULTS_URL . '\'

					otaboLoadForm(' . json_encode($osd) . ');
				});
				
			</script>
			
			<fieldset id="otabo_form">

				<p>' . $strings['checkout_base'] . '</p>
				<div class="input">
					<input type="text" placeholder="' . $strings['label_select'] . '" id="otabo_checkout_base" />
					<ul id="otabo_checkout_base_list">
					</ul>
				</div>
				<p id="otabo_checkin_base_select_tick">
					<input type="checkbox" id="otabo_checkin_base_select" />
					<span>' . $strings['checkin_base_select'] . '</span>
				</p>
				<p id="otabo_checkin_base_label" style="display: none">' . $strings['checkin_base'] . '</p>
				<div class="input" style="display: none">
					<input type="text" placeholder="' . $strings['label_select'] . '" id="otabo_checkin_base" />
					<ul id="otabo_checkin_base_list">
					</ul>
				</div>
				<div class="calendar_holder">
					<p>' . $strings['checkout_date'] . '</p>
					<div class="calendar">
						<p id="otabo_checkout_date">Seleziona…</p>
						<div id="otabo_checkout_date_calendar">
							<img src="' . plugin_dir_url(__FILE__) . 'images/icon_arrow_left.png" id="otabo_checkout_date_left"/>
							<h1 id="otabo_checkout_date_title">Gennaio</h1>
							<img src="' . plugin_dir_url(__FILE__) . 'images/icon_arrow_right.png" id="otabo_checkout_date_right"/>
							<table>
								<thead>
									<tr>
										<th>L</th><th>M</th><th>M</th><th>G</th><th>V</th><th>S</th><th>D</th>
									</tr>
								</thead>
								<tbody id="otabo_checkout_date_table">
								</tbody>
							</table>
						</div>
					</div>
					<div class="input">
						<input type="text" placeholder="' . $strings['label_select'] . '" id="otabo_checkout_time_input" />
						<ul id="otabo_checkout_time">
						</ul>
					</div>
				</div><div class="calendar_holder">
					<p>' . $strings['checkin_date'] . '</p>
					<div class="calendar">
						<p id="otabo_checkin_date">Seleziona…</p>
						<div id="otabo_checkin_date_calendar">
							<img src="' . plugin_dir_url(__FILE__) . 'images/icon_arrow_left.png" id="otabo_checkin_date_left"/>
							<h1 id="otabo_checkin_date_title"></h1>
							<img src="' . plugin_dir_url(__FILE__) . 'images/icon_arrow_right.png" id="otabo_checkin_date_right"/>
							<table>
								<thead>
									<tr>
										<th>L</th><th>M</th><th>M</th><th>G</th><th>V</th><th>S</th><th>D</th>
									</tr>
								</thead>
								<tbody id="otabo_checkin_date_table">
								</tbody>
							</table>
						</div>
					</div>
					<div class="input">
						<input type="text" placeholder="' . $strings['label_select'] . '" id="otabo_checkin_time_input" />
						<ul id="otabo_checkin_time">
						</ul>
					</div>
				</div>

				<button id="otabo_check_dates">' . $strings['label_search'] . '</button>
				
				<div id="otabo_error">
					<p id="otabo_error_msg"></p>
				</div>

			</fieldset>
			
			<div class="loading" id="otabo_loading">
				<img class="loading_1" src="' . plugin_dir_url(__FILE__) . 'images/loading_dot.png" />
				<img class="loading_2" src="' . plugin_dir_url(__FILE__) . 'images/loading_dot.png" />
				<img class="loading_3" src="' . plugin_dir_url(__FILE__) . 'images/loading_dot.png" />
			</div>


		</div>';
		
		return $form;
	}
	
	function postResults($attr)
	{
		$strings = array_map(function($e) { return str_replace('\'', '\\\'', $e); }, $this->STRINGS[OTABO_LANG]);
		
		$ot = isset($_GET['ot']) ? new DateTime($_GET['ot'], new DateTimeZone('UTC')) : NULL;
		$it = isset($_GET['it']) ? new DateTime($_GET['it'], new DateTimeZone('UTC')) : NULL;
		
		if (!$_GET['osd'] && (!isset($_GET['ob']) || !$ot || !$it))
		{
			return '<script> window.location = \'' . OTABO_FORM_URL . '\'; </script>';
		}
		
		$form = '

		<div class="otabo">
			<script>
				
				var _S = ' . json_encode($strings) . ';
				jQuery(function( $ )
				{
					OTABO_GW_URL = \'' . admin_url('admin-ajax.php') . '\';
					OTABO_IMG_DIR = \'' . plugin_dir_url(__FILE__) . 'images/\';
					OTABO_LANG = \'' . $lang . '\';

					OTABO_BOOKING_COVERAGES_URL = \'' . OTABO_BOOKING_COVERAGES_URL . '\'
					OTABO_BOOKING_OPTIONALS_URL = \'' . OTABO_BOOKING_OPTIONALS_URL . '\'
					OTABO_BOOKING_URL = \'' . OTABO_BOOKING_URL . '\'
					OTABO_CONFIRM_URL = \'' . OTABO_CONFIRM_URL . '\'
					OTABO_FORM_URL = \'' . OTABO_FORM_URL . '\'
					OTABO_RESULTS_URL = \'' . OTABO_RESULTS_URL . '\'
					
					' . (isset($_GET['ot']) && isset($_GET['it']) ? 
							'document.getElementById(\'otabo_checkout_time\').innerHTML = otaboFormatDate(\'' . $_GET['ot'] . '\');
							document.getElementById(\'otabo_checkin_time\').innerHTML = otaboFormatDate(\'' . $_GET['it'] . '\');' : '') . '

					' . (isset($_GET['ob']) && $ot && $it ?
							'otaboLoadResults(' . json_encode($_GET['osd']) . ', ' . json_encode($_GET['ob']) . ', ' . json_encode($_GET['ib']) . ', '
									. json_encode($_GET['ot']) . ', '. json_encode($_GET['it']) . ');' :
							'otaboLoadResults(' . json_encode($_GET['osd']) . ');') . '
				});
				
			</script>
			
			<div id="otabo_results_header">
				<ul>
					<li>
						<span class="input">' . $strings['results_checkout'] . '</span>
						<span class="base" id="otabo_checkout_base">' . (isset($_GET['obs']) ? $_GET['obs'] : '') . '</span>
						<span class="date" id="otabo_checkout_time"></span>
					</li><li>
						<span class="input">' . $strings['results_checkin'] . '</span>
						<span class="base" id="otabo_checkin_base">' . (isset($_GET['ibs']) && strlen($_GET['ibs']) > 0 ? $_GET['ibs'] : isset($_GET['obs']) ? $_GET['obs'] : '') . '</span>
						<span class="date" id="otabo_checkin_time"></span>
					</li>
				</ul>
			</div>

			<div id="otabo_results_groups">
			</div>
			
			<div id="otabo_results">
			</div>

			<div id="otabo_error">
				<p id="otabo_error_msg"></p>
			</div>

			<div class="loading" id="otabo_loading">
				<img class="loading_1" src="' . plugin_dir_url(__FILE__) . 'images/loading_dot.png" />
				<img class="loading_2" src="' . plugin_dir_url(__FILE__) . 'images/loading_dot.png" />
				<img class="loading_3" src="' . plugin_dir_url(__FILE__) . 'images/loading_dot.png" />
			</div>

		</div>';
		
		return $form;
	}
	
	function printSoapError($client)
	{
		$reqdom = new DOMDocument();
		$reqdom->preserveWhiteSpace = false;
		$reqdom->formatOutput = true;
		$reqdom->loadXML($client->__getLastRequest());

		$dom = new DOMDocument();
		$dom->preserveWhiteSpace = false;
		$dom->formatOutput = true;
		$dom->loadXML($client->__getLastResponse());

		$res = '';
		$errors = $dom->getElementsByTagName('Error');
		
		for ($i = 0; $i < count($errors); $i++)
		{
			$res .= ($res == '' ? '' : "\n");
			$res .= $errors[$i]->getAttribute('Code') . ' - ' . $errors[$i]->getAttribute('ShortText');
		}
		
		return $res;
	}
}

function register_session_new()
{
	if(!session_id())
	{
		session_start();
	}
}

add_action('init', 'register_session_new');

function otabo_init()
{
	$otabo = new Otabo();

	add_action('wp_enqueue_scripts', array($otabo, 'addScripts'));
	add_action('wp_ajax_nopriv_oaj', array($otabo, 'ajax'));

	add_shortcode('otabo_booking_no', array($otabo, 'postBookingNo'));
	add_shortcode('otabo_booking_coverages', array($otabo, 'postBookingCoverages'));
	add_shortcode('otabo_booking_details', array($otabo, 'postBookingDetails'));
	add_shortcode('otabo_booking_optionals', array($otabo, 'postBookingOptionals'));
	add_shortcode('otabo_booking_summary', array($otabo, 'postBookingSummary'));
	add_shortcode('otabo_form', array($otabo, 'postForm'));
	add_shortcode('otabo_results', array($otabo, 'postResults'));

	function otabo_field_input($key)
	{
 		echo '<input type="text" id="' . $key . '" name="' . $key . '" value="' . esc_attr(get_option($key)) . '" />';
	};
	
	function otabo_field_page($key)
	{
		echo '<select id="' . $key  . '" name="' . $key . '">';

		$option = get_option($key);
		if ($pages = get_pages())
		{
			foreach ($pages as $page)
			{
				echo '<option value="' . $page->ID . '" ' . selected($page->ID, $option) . '>' . $page->post_title . '</option>';
			}
		}

		echo '</select>';
	};
		
	function otabo_register_settings()
	{
		$fields = array
		(
			'otabo_auth' => array
			(
				'name' => 'Authentication',
				'fields' => array
				(
					'uuid' => 'UUID',
					'api_key' => 'API Key',
				),
			),
			
			'otabo_pages' => array
			(
				'name' => 'Pages',
				'fields' => array
				(
					'form_url' => 'Form page',
					'results_url' => 'Results page',
					'coverages_url' => 'Coverages page',
					'optionals_url' => 'Optionals page',
					'booking_url' => 'Booking page',
					'confirm_url' => 'Confirmation page',
				),
			),
			
			'otabo_links' => array
			(
				'name' => 'Links',
				'fields' => array
				(
					'terms_url' => 'Terms and Conditions',
					'privacy_url' => 'Privacy Policy',
				),
			),
		);
		
		foreach ($fields as $k => $v)
		{
			add_settings_section($k, $v['name'], '', 'otabo-slug');
			
			foreach ($v['fields'] as $kk => $vv)
			{
				register_setting('otabo_options', $kk, 'sanitize_text_field' );
				add_settings_field($kk, $vv, $k == 'otabo_pages' ? 'otabo_field_page' : 'otabo_field_input', 'otabo-slug', $k, $kk);
			}
		};
	}
		
	function otabo_options_page()
	{
		echo '
			<div class="wrap">
				<h1>Otabo Settings</h1>
				<form method="post" action="options.php">';
	
		settings_fields('otabo_options'); // settings group name
		do_settings_sections('otabo-slug'); // just a page slug

		submit_button();
		
		echo '<h1>Otabo Content Elements</h1>
			<p>All content elements provided by the Otabo plugin are textual based and can be included in any page, post, ecc. of the page by using the following syntax: <b>[element_name]</b>.
				The following list explains all the elements available.</p>
			<dl>
				<dt>[otabo_form]</dt>
				<dd>Prints the form that allows you to choose pickup/drop-off stations and dates and times.</dd>
				
				<dt>[otabo_results]</dt>
				<dd>Shows a list of results that matched the given search criteria provided by the form.</dd>
				
				<dt>[otabo_booking_coverages]</dt>
				<dd>After selecting a specific vehicle, one of its coverage options (if available) has to be selected to go ahead. This element lists all the available options.</dd>
				
				<dt>[otabo_booking_optionals]</dt>
				<dd>Shows a list with bookable extras, such as navigators, child seats, ecc.</dd>
				
				<dt>[otabo_booking_details]</dt>
				<dd>Prints the form that lets you insert all of your personal details that are necessary to perform the booking. This is the last step of the booking process.</dd>
				
				<dt>[otabo_booking_no]</dt>
				<dd>Returns the booking number after a booking has been made. This element serves only as a placeholder and can easily be integrated in a floating text, such as:
					<i>Congratulations, your quote no. [otabo_booking_no] has been successfully submitted and confirmed.</i>.</dd>
				
				<dt>[otabo_booking_summary]</dt>
				<dd>Prints a table summarizing the current booking choices, such as the chosen vehicle, coverage option and extras.</dd>
			</dl>
		</div></form>';
	}
	
	function otabo_register_options_page()
	{
		add_options_page('Otabo', 'Otabo', 'manage_options', 'otabo', 'otabo_options_page');
	}
	
	add_action('admin_init', 'otabo_register_settings');
	add_action('admin_menu', 'otabo_register_options_page');
}

add_action('init', 'otabo_init');

?>